// deSeparations/deChannel
// JavaScript for Adobe Illustrator version 10 and higer
// Version 0.4
// (c) vd [vd@online.com.ua]
// (i) vd
 
// This software is distributed under the  
// terms of GNU General Public License.
// http://www.gnu.org/licenses/gpl.html


// ----------------------------------------------------- 

language = ""

// ----------------------------------------------------- 

var techName = '_deChannel';
var tagName = '_despn03_';
var ver = parseInt(version);

switch(language) {
	case "deutsch":
		happyend = 'Verwendung: \xDCberdruckenvorschau im Ansicht-Men\xFC aktivieren und in der neuen Ebene "'+techName+'"\nden gew\xFCnschten Kanal durch aktiviern der entsprechenden Unterebene einblenden.';
		break;

	case "ukrainian":
		happyend = '\u0423\u0432\u0456\u043C\u043A\u043D\u0456\u0442\u044C Overprint Preview, \u0449\u043E\u0431 \u0432\u0456\u0440\u043D\u043E \u0432\u0456\u0434\u043E\u0431\u0440\u0430\u0437\u0438\u0442\u0438 spot \u043A\u043E\u043B\u044C\u043E\u0440\u0438';
		break;

	default:
		happyend = 'To correctly display spot-color channels you should turn on: View -> Overprint Preview';
		break;
}

if(documents.length>0) { docRef = activeDocument;

if(docRef && (docRef.documentColorSpace == DocumentColorSpace.CMYK)) {
	
	var Separated = false;
	for( i=0; i<docRef.tags.length && Separated == false; i++ ) if(docRef.tags[i].name == tagName) Separated = true;

	if(Separated) {
		for(i=0;i<docRef.layers.length;i++) {
			if((docRef.layers[i].name == techName) || (docRef.layers[i].name == '_White Background')) {
				docRef.layers[i].visible = true;
				docRef.layers[i].locked = false;
				docRef.layers[i].remove();			
			}
		} 	
	}
	else {
		var origin = docRef.rulerOrigin;
		var nColor = new CMYKColor();

		boundLeft   = -origin[0];
		boundTop    = -origin[1];
		boundWidth  = docRef.width;
		boundHeight = -docRef.height;	

		// Background
		var SBG = docRef.layers.add();
		SBG.name = "_White Background";
		SBG.zOrder(ZOrderMethod.SENDTOBACK);
	
		var iBG = SBG.pathItems.rectangle(boundTop,boundLeft,boundWidth,boundHeight);
		iBG.name = "White background";
		iBG.stroked = false;
	
		nColor.cyan = 0;
		nColor.magenta = 0;
		nColor.yellow = 0;
		nColor.black = 0;
	
		iBG.filled = true;
		ver > 10 ? iBG.fillColor = nColor : iBG.fillColor.cmyk = nColor;
		iBG.blendingMode = BlendModes.NORMAL;
		iBG.locked = true;
	
		// Separations
		var SL = docRef.layers.add();
		SL.name = techName;
		SL.zOrder(ZOrderMethod.BRINGTOFRONT);

		// Spot Colors
		var nSpot = new SpotColor();
		var spots = 0;

		for(i=docRef.spots.length-1;i>=0;i--) 
		if(docRef.spots[i].colorType == ColorModel.SPOT) {
			spots++;			
			var iS = SL.pathItems.rectangle(boundTop,boundLeft,boundWidth,boundHeight);
			iS.name = docRef.spots[i].name;
			iS.stroked = false;

			iS.filled = true;
			nSpot.spot = docRef.spots[i];
			ver > 10 ? iS.fillColor = nSpot : iS.fillColor.spot = nSpot;
			iS.blendingMode = BlendModes.LIGHTEN;
			iS.isIsolated = true;
			iS.locked = true;
			iS.hidden = true;			
		}
	
		// Black (Key)
		if(InkPrint(3)) {
			var iK = SL.pathItems.rectangle(boundTop,boundLeft,boundWidth,boundHeight);
			iK.name = "Black";
			iK.stroked = false;
	
			nColor.cyan = 0;
			nColor.magenta = 0;
			nColor.yellow = 0;
			nColor.black = 100;
	
			iK.filled = true;
			ver > 10 ? iK.fillColor = nColor : iK.fillColor.cmyk = nColor;
			iK.blendingMode = BlendModes.LIGHTEN;
			iK.isIsolated = true;
			iK.locked = true;
			iK.hidden = true;
		}
	
	
		// Yellow
		if(InkPrint(2)) {
			var iY = SL.pathItems.rectangle(boundTop,boundLeft,boundWidth,boundHeight);
			iY.name = "Yellow";
			iY.stroked = false;
	
			nColor.cyan = 0;
			nColor.magenta = 0;
			nColor.yellow = 100;
			nColor.black = 0;
	
			iY.filled = true;
			ver > 10 ? iY.fillColor = nColor : iY.fillColor.cmyk = nColor;
			iY.blendingMode = BlendModes.LIGHTEN;
			iY.isIsolated = true;
			iY.locked = true;
			iY.hidden = true;
		}	
		
		// Magenta
		if(InkPrint(1)) {
			var iM = SL.pathItems.rectangle(boundTop,boundLeft,boundWidth,boundHeight);
			iM.name = "Magenta";
			iM.stroked = false;
	
			nColor.cyan = 0;
			nColor.magenta = 100;
			nColor.yellow = 0;
			nColor.black = 0;
	
			iM.filled = true;
			ver > 10 ? iM.fillColor = nColor : iM.fillColor.cmyk = nColor;
			iM.blendingMode = BlendModes.LIGHTEN;
			iM.isIsolated = true;
			iM.locked = true;
			iM.hidden = true;
		}
	
		// Cyan
		if(InkPrint(0)) {
			var iC = SL.pathItems.rectangle(boundTop,boundLeft,boundWidth,boundHeight);
			iC.name = "Cyan";
			iC.stroked = false;
	
			nColor.cyan = 100;
			nColor.magenta = 0;
			nColor.yellow = 0;
			nColor.black = 0;
	
			iC.filled = true;
			ver > 10 ? iC.fillColor = nColor : iC.fillColor.cmyk = nColor;
			iC.blendingMode = BlendModes.LIGHTEN;
			iC.isIsolated = true;
			iC.locked = true;
		}	

		// Tag
		var tag = iBG.tags.add();
		tag.name = tagName;
		tag.value = 'enabled';
		SBG.locked = true;

		if(spots>0) alert(happyend);
	}
}}

function InkPrint(inkN) {
	if(ver < 11) return true;
	else if(activeDocument.inkList[inkN].inkInfo.printingStatus == InkPrintStatus.ENABLEINK) return true;
	else return false;
}