// deSeparations/deMixer
// JavaScript for Adobe Illustrator version 10 and higer
// Version 0.4
// (c) vd [vd@online.com.ua]
// (i) Minherz
 
// This software is distributed under the  
// terms of GNU General Public License.
// http://www.gnu.org/licenses/gpl.html


// ----------------------------------------------------- 

language = ""

// ----------------------------------------------------- 

var techName = '_deMixer';
var tagName = '_demxr03_';
var tagAdded = false;
var ver = parseInt(version);

switch(language) {
	case "deutsch":
		happyend = 'Verwendung: \xDCberdruckenvorschau im Ansicht-Men\xFC aktivieren und in der neuen Ebene "'+techName+'"\nden gew\xFCnschten Kanal durch aktiviern der entsprechenden Unterebene ausblenden.';
		fail = 'Nichts zu separieren.';
		break;

	case "ukrainian":
		happyend = '\u0423\u0432\u0456\u043C\u043A\u043D\u0456\u0442\u044C Overprint Preview, \u0442\u0430 \u0432 \u043D\u043E\u0432\u043E\u043C\u0443 \u0448\u0430\u0440\u0456 '+techName+' \u043E\u0431\u0435\u0440\u0456\u0442\u044C \u043A\u0430\u043D\u0430\u043B, \u043A\u043E\u043B\u0456\u0440 \u044F\u043A\u043E\u0433\u043E \u043F\u043E\u0442\u0440\u0435\u0431\u0443\u0454\u0442\u044C\u0441\u044F \u043F\u0440\u0438\u0445\u043E\u0432\u0430\u0442\u0438';
		fail = '\u041F\u043E\u0440\u043E\u0436\u043D\u0456\u0439 \u0434\u043E\u043A\u0443\u043C\u0435\u043D\u0442?';
		break;

	default:
		happyend = 'Turn on: View -> Overprint Preview\nNow in new '+techName+' layer just make visible channel you want to hide';
		fail = 'Nothing to separate.';
		break;
}


if(documents.length>0) { docRef = activeDocument;

if(docRef && (docRef.documentColorSpace == DocumentColorSpace.CMYK)) {

	var Separated = false;
	for( i=0; i<docRef.tags.length && Separated == false; i++ ) if(docRef.tags[i].name == tagName) Separated = true;

	if(Separated) { 
		CleanUp(docRef)
	}
	else {
		var origin = docRef.rulerOrigin;
		var nColor = new CMYKColor();
	
		var SL = docRef.layers.add();
		SL.name = techName;
		SL.zOrder(ZOrderMethod.BRINGTOFRONT);
	
		boundLeft   = -origin[0];
		boundTop    = -origin[1];
		boundWidth  = docRef.width;
		boundHeight = -docRef.height;

		// Spot Colors
		var nSpot = new SpotColor();

		for(i=docRef.spots.length-1;i>=0;i--) 
		if(docRef.spots[i].colorType == ColorModel.SPOT) {
			var iS = SL.pathItems.rectangle(boundTop,boundLeft,boundWidth,boundHeight);
			iS.name = '-'+docRef.spots[i].name;
			iS.stroked = false;

			iS.filled = true;
			nSpot.spot = docRef.spots[i];
			nSpot.tint = 0.5;
			ver >= 11 ? iS.fillColor = nSpot : iS.fillColor.spot = nSpot;
			iS.fillOverprint = true;
			iS.isIsolated = false;
			iS.locked = true;
			iS.hidden = true;
			
			AddTag(iS);
		}

		// Black (Key)
		if(InkPrint(3)) {
			var iK = SL.pathItems.rectangle(boundTop,boundLeft,boundWidth,boundHeight);
			iK.name = "-Black";
			iK.strokeWidth = 0;
	
			nColor.cyan = 0;
			nColor.magenta = 0;
			nColor.yellow = 0;
			nColor.black = .5;
	
			iK.filled = true;
			ver >= 11 ? iK.fillColor = nColor : iK.fillColor.cmyk = nColor;
			iK.fillOverprint = true;
			iK.locked = true;
			iK.hidden = false;
			
			AddTag(iK);
		}
	
	
		// Yellow
		if(InkPrint(2)) {
			var iY = SL.pathItems.rectangle(boundTop,boundLeft,boundWidth,boundHeight);
			iY.name = "-Yellow";
			iY.strokeWidth = 0;
	
			nColor.cyan = 0;
			nColor.magenta = 0;
			nColor.yellow = .5;
			nColor.black = 0;
	
			iY.filled = true;
			ver >= 11 ? iY.fillColor = nColor : iY.fillColor.cmyk = nColor;
			iY.fillOverprint = true;
			iY.locked = true;
			iY.hidden = true;
			
			AddTag(iY);
		}
	
		// Magenta
		if(InkPrint(1)) {
			var iM = SL.pathItems.rectangle(boundTop,boundLeft,boundWidth,boundHeight);
			iM.name = "-Magenta";
			iM.strokeWidth = 0;
	
			nColor.cyan = 0;
			nColor.magenta = .5;
			nColor.yellow = 0;
			nColor.black = 0;
	
			iM.filled = true;
			ver >= 11 ? iM.fillColor = nColor : iM.fillColor.cmyk = nColor;
			iM.fillOverprint = true;
			iM.locked = true;
			iM.hidden = true;
			
			AddTag(iM);
		}
	
		// Cyan
		if(InkPrint(0)) {
			var iC = SL.pathItems.rectangle(boundTop,boundLeft,boundWidth,boundHeight);
			iC.name = "-Cyan";
			iC.strokeWidth = 0;
	
			nColor.cyan = .5;
			nColor.magenta = 0;
			nColor.yellow = 0;
			nColor.black = 0;
	
			iC.filled = true;
			ver >= 11 ? iC.fillColor = nColor : iC.fillColor.cmyk = nColor;
			iC.fillOverprint = true;
			iC.locked = true;
			iC.hidden = true;
			
			AddTag(iC);
		}
	
		// Tag
		if(!tagAdded) {
			CleanUp(docRef);
			alert(fail);
		}
		else
			alert(happyend);
	}
}}

function CleanUp(doc) 
{
	for(i=0;i<doc.layers.length;i++) {
		if(doc.layers[i].name == techName) {
			doc.layers[i].visible = true;
			doc.layers[i].locked = false;
			doc.layers[i].remove();			
		}
	}
}

function AddTag(layer)
{
	if(!tagAdded) {
		tag = layer.tags.add();
		tag.name = tagName;
		tag.value = 'enabled';
		tagAdded = true;
	}
}

function InkPrint(inkN) {
	if(ver < 11) return true;
	else if(activeDocument.inkList[inkN].inkInfo.printingStatus == InkPrintStatus.ENABLEINK) return true;
	else return false;
}